/*
 * Packet.cpp
 *
 *  Created on: Apr 2, 2021
 *      Author: astrisw
 */


#include <Astri_Packet.h>

#include <math.h>

/*
 * Packet constructor
 *
 * @param packetPath: path of the xml file of the packet.
 *
 */

AstriPacket::AstriPacket(std::string packetPath) : BasePacket(packetPath) {
	this->type = 0;
	this->subType = 0;
	this->telescopeId = 0;
}

unsigned short AstriPacket::getType(){
	return type;
}
unsigned short AstriPacket::getSubType(){
	return subType;
}

unsigned short AstriPacket::getTelescopeID(){
	return telescopeId;
}

void AstriPacket::updateFromBuffer(){
	this->type = header_field_values["Packet Type"];
	this->subType = header_field_values["Packet SubType"];
	this->crc = header_field_values["CRC Flag"];
	this->ssc = header_field_values["Source Sequence Counter"];
	this->telescopeId = header_field_values["TelescopeID"];
}

void AstriPacket::updatePayloadSize(){
	this->payload_size = header_field_values["Packet Length"] -1;
}


